!Declarations of ToolBar Classes and Types

OMIT('_EndOfInclude_',_UserDefindedToolBarPresent_)
_UserDefindedToolBarPresent_ EQUATE(1)

ToolBarControlType:Button        EQUATE(1)
ToolBarControlType:CheckBox      EQUATE(2)
ToolBarControlType:RadioButton   EQUATE(3)
ToolBarControlType:Option        EQUATE(4)
ToolBarControlType:DropList      EQUATE(5)

ToolBarControlType:LastFlated    EQUATE(ToolBarControlType:RadioButton)
ToolBarControlType:LastProcessed EQUATE(10)

ToolBarControlType:Delimiter     EQUATE(ToolBarControlType:LastProcessed + 1)
ToolBarControlType:SingleOffset  EQUATE(ToolBarControlType:LastProcessed + 2)
ToolBarControlType:DoubleOffset  EQUATE(ToolBarControlType:LastProcessed + 3)
ToolBarControlType:TrippleOffset EQUATE(ToolBarControlType:LastProcessed + 4)

ToolBarControlType:LastCreated   EQUATE(ToolBarControlType:Delimiter)


ToolBarDockedStatus:NotDefined   EQUATE(-1)
ToolBarDockedStatus:NotVisible   EQUATE(0)
ToolBarDockedStatus:Left         EQUATE(DOCK:Left)
ToolBarDockedStatus:Top          EQUATE(DOCK:Top)
ToolBarDockedStatus:Right        EQUATE(DOCK:Right)
ToolBarDockedStatus:Bottom       EQUATE(DOCK:Bottom)
ToolBarDockedStatus:Float        EQUATE(DOCK:Float)


!--------------------------------------------------
QueueControlsType    QUEUE,TYPE
sgItemControl          SIGNED
sgParentControl        SIGNED
stItemIcon             STRING(120)
stItemTip              STRING(120)
stItemAction           STRING(20)
byItemType             BYTE
byCounterRadio         BYTE
shWidth                SHORT
                     END

QueuePosType         QUEUE,TYPE
byCoeff                BYTE
shHeight               SHORT
shWidth                SHORT
shVirtualHeight        SHORT
shVirtualWidth         SHORT
                     END

ToolBarFile          FILE,DRIVER('Clarion'),OEM,PRE(TLB),BINDABLE,CREATE,THREAD,EXTERNAL(''),DLL(dll_mode)
KeyID                  KEY(TLB:ID),NOCASE,OPT,PRIMARY !   
KeyDescription         KEY(TLB:Type,TLB:Description),DUP,NOCASE,OPT !     
Record                 RECORD,PRE()
ID                        BYTE                      ! 
Description               STRING(40)                ! 
Type                      BYTE                      ! 
Icon                      STRING(120)               ! 
Tip                       STRING(120)               ! 
Action                    STRING(20)                !
                       END
                     END

SettingFile          FILE,DRIVER('Clarion'),OEM,PRE(TBS),BINDABLE,CREATE,THREAD,EXTERNAL(''),DLL(dll_mode)
KeyIDNumberTB          KEY(TBS:ID,TBS:NumberTB),NOCASE,OPT !      
Record                 RECORD,PRE()
ID                        BYTE                      ! 
NumberTB                  BYTE                      !  
                       END
                     END

ToolBarType CLASS,TYPE,MODULE('TLBCode.Clw'),EXTERNAL,DLL(dll_mode)
ParentWindow          &WINDOW,PRIVATE
ToolbarWindow         &WINDOW,PRIVATE
QueueControls         &QueueControlsType,PRIVATE
QueuePos              &QueuePosType,PRIVATE
InstanceNumber        SIGNED,PRIVATE
ParentToolbarThread   SIGNED,PRIVATE
INIFileName           STRING(128),PRIVATE
TBWindowHeader        STRING(60),PRIVATE
ToolBarPathFile       STRING(128),PRIVATE
ToolBarStatus         BYTE,PRIVATE
ToolBarShow           BYTE,PRIVATE
Variable              ANY,PRIVATE

PrepareControls       PROCEDURE,VIRTUAL
ProcessControls       PROCEDURE,VIRTUAL
BindingVariable       PROCEDURE,VIRTUAL
            END

!--------------------------------------------------

QueueToolBarType     QUEUE,TYPE
ToolBar                &ToolBarType
ToolBarInstance        SIGNED
ToolbarThread          SIGNED
                     END

SupervisorToolBarType CLASS,TYPE,MODULE('TLBCode.Clw'),EXTERNAL,DLL(dll_mode)
QueueToolBar             &QueueToolBarType,PRIVATE
ParentWindow             &WINDOW,PRIVATE
INIFileName              STRING(128),PRIVATE
ToolBarPathFile          STRING(128),PRIVATE
ProcessError             BYTE,PRIVATE

Initialize               PROCEDURE(STRING INIFileName,STRING ToolBarPathFile,BYTE ProcessError)
Kill                     PROCEDURE
AddInstanceToolBar       PROCEDURE(ToolBarType ToolBar,STRING TBWindowHeader,SIGNED InstanceNumber)
LaunchToolBar            PROCEDURE(SIGNED InstanceNumber,STRING ParentWindow,STRING Docked)
GetMaxInstance           PROCEDURE,SIGNED
PresentInstance          PROCEDURE(SIGNED InstanceNumber),BYTE
GetWindowHeader          PROCEDURE(SIGNED InstanceNumber),STRING
GetINIFileName           PROCEDURE,STRING
GetToolBarPath           PROCEDURE,STRING
GetAction                PROCEDURE(SIGNED InstanceNumber),STRING
GetToolBarStatus         PROCEDURE(SIGNED InstanceNumber),BYTE

DisplayToolBars          PROCEDURE
RebuildToolBars          PROCEDURE
StopToolBar              PROCEDURE(SIGNED InstanceNumber)
BreakToolBar             PROCEDURE(SIGNED InstanceNumber)
ShowToolBar              PROCEDURE(SIGNED InstanceNumber)
ShowToolBar              PROCEDURE
HideToolBar              PROCEDURE(SIGNED InstanceNumber)
HideToolBar              PROCEDURE
EnableControl            PROCEDURE(SIGNED InstanceNumber,STRING Action)
DisableControl           PROCEDURE(SIGNED InstanceNumber,STRING Action)
GetDockedStatus          PROCEDURE(SIGNED InstanceNumber),BYTE
                      END

!--------------------------------------------------

_EndOfInclude_
